from aqt.qt import *

class ProgressWindow(QDialog):

    def __init__(self, text, title, parent=None):
        super(ProgressWindow, self).__init__(parent)

        self.was_closed = False

        self.setWindowModality(Qt.ApplicationModal)

        self.setWindowTitle(title)

        self.lyt = QVBoxLayout(self)

        if text:
            self.lyt.addWidget(QLabel(text))

        self.bar = QProgressBar()
        self.bar.setMinimumWidth(300)
        self.bar.setMinimum(0)
        self.bar.setMaximum(100)
        self.bar.setValue(0)
        self.lyt.addWidget(self.bar)

        self.button_box = QDialogButtonBox()
        self.button_box.addButton('Cancel', QDialogButtonBox.AcceptRole)
        self.lyt.addWidget(self.button_box)
        self.button_box.accepted.connect(self.accept)

        self.setFixedSize(self.sizeHint())
    
    def set_value(self, value):
        val = round(value*100)
        val = min(100, max(0, val))
        self.bar.setValue(val)

    def accept(self):
        self.was_closed = True
        QDialog.accept(self)

    def reject(self):
        self.accept()